/*
 * Copyright (c) 2015 Ziver
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.page;

import wa.server.WAContext;
import wa.server.page.struct.WANavigation;
import wa.server.plugin.WAStatus;
import zutil.net.http.HttpHeader;
import zutil.parser.DataNode;
import zutil.parser.Templator;
import zutil.plugin.PluginManager;

import java.util.ArrayList;
import java.util.Map;

/**
 * Created by Ziver on 2015-04-06.
 */
public class StatusPage implements WAPage {
    public static final String NAVIGATION_NAME = "Status";
    private ArrayList<WAStatus> plugins;

    public StatusPage(PluginManager pluginManager){
        this.plugins = pluginManager.toArray(WAStatus.class);

        WANavigation nav = WANavigation.createRootNav(NAVIGATION_NAME);
        nav.setResource(this);
        for(WAStatus plugin : plugins)
            nav.createSubNav(plugin.getName()).setResource(plugin);
    }


    @Override
    public Templator htmlResponse(WAContext context,
                                  HttpHeader client_info,
                                  Map<String, Object> session,
                                  Map<String, String> cookie,
                                  Map<String, String> request) {

        WAStatus obj = getPlugin(context);
        if(obj != null) {
            return new Templator(obj.html());
        }
        return null;
    }

    public DataNode jsonResponse(WAContext context,
                                 HttpHeader client_info,
                                 Map<String, Object> session,
                                 Map<String, String> cookie,
                                 Map<String, String> request){
        // Do JSON request in all status plugins
        DataNode root = new DataNode(DataNode.DataType.Map);
        for(WAStatus obj : plugins) {
            if (obj != null)
                obj.jsonUpdate(request, root);
        }
        return root;
    }


    private WAStatus getPlugin(WAContext context){
        if(context.getBreadcrumb().size() >= 2){
            int i = plugins.indexOf(context.getBreadcrumb().get(1).getResource());
            if(i >= 0)
                return plugins.get(i);
        }
        return null;
    }

}
